/*
   Pseudo

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2006 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

import java.text.* ;
import java.util.* ;

class MsetCoder extends Coder {
  private char [] decode ;
  private Hash code ;
  
  MsetCoder (String s) {
    String [] t = new String [s.length()] ;
    for (int k = 0 ; k < s.length() ; k++) {
      t[k] = "" + s.charAt(k) ;
    }
    Collator col = Collator.getInstance() ;
    Arrays.sort(t, col) ;

    int nchars = 0 ;
    String prev = "" ;
    code = new Hash () ;
    for (int k = 0 ; k < s.length() ; k++) {
      if (!prev.equals(t[k])) {
        code.set(t[k].charAt(0), (char)nchars++) ;
        prev = t[k] ;
      }
    }
    decode = code.inverse() ;
  }

  int code(char x) { return code.get(x) ; }

  private static StringBuffer r = new StringBuffer () ;

  String code(String s) {
    r.setLength(0) ;
    int len = s.length() ;
    for (int k = 0 ; k < len ; k++) {
      int c = code.get(s.charAt(k)) ;
      if (c < 0) {
        return null ;
      }
      r.append((char)c) ;
    }
    return r.toString() ;
  }


  char decode(char x) { return decode[x] ; }

  char decode(int x) { return decode[x] ; }

  String decode(String s) {
    r.setLength(0) ;
    int len = s.length() ;
    for (int k = 0 ; k < len ; k++) {
      r.append(decode[s.charAt(k)]) ;
    }
    return r.toString() ;
  }

  int card() { return code.card() ; }

  public String toString() {
    StringBuffer r = new StringBuffer () ;
    for (int k = 0 ; k < decode.length ; k++) {
      r.append("<" + decode[k] + ">") ;
    }
    r.append("\n") ;
    r.append(code.toString()) ;
    return r.toString() ;
  }

  public static void main(String [] arg) {
    Coder c = new MsetCoder(arg[0]) ;    
  }
}
