import java.io.* ;
import java.util.* ;

/*
   Pseudo

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2006 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class Subs {
  protected Tree start ;

  protected Coder coder ;

  /* Produce anagrams */

  private Controler ctrl ;

  private void all(Tree t, Words ws, String prev, int depth) {
    if (verbose > 1) {
      System.err.println("ALL: " + ws + "") ;
    }
    int low = depth < prev.length() ? prev.charAt(depth) : -1 ;
    for ( ; t != null && t.val < low ; t = t.right) ;
    if (t == null) return ;
    if (t.val > low) { prev = "" ; }
    for ( ; t != null ; t = t.right) {
      if (ctrl.transition(t.val)) {
        ws.push(t.val) ;
        if (t.eow > 0 && (t.val > low || depth+1 == prev.length())) {
          if (ctrl.accept()) {
            System.out.println(ws) ;
          }
          if (ctrl.pushWord()) {
            String p = ws.pushWord() ;
            all(start, ws, p, 0) ;
            ws.popWord() ;
            ctrl.popWord() ;
          }
        }
        all(t.down, ws, prev, depth+1) ;
        ws.pop() ;
        ctrl.back(t.val) ;
      }
      prev = "" ;
    }
  }

  void all() {
    all(start, new Words(coder), "", 0) ;
  }

  protected Tree insertSub(Tree t, String w, boolean eow) {
    String sub = coder.code(w) ;
    if (sub == null) { return t ; }
    if (ctrl.goodWord(sub)) {
      return Tree.insert(t, sub, eow) ;
    } else {
      return t ;
    }
  }

  protected void treatWord(String w) { } 

  protected int verbose ;

  // Constructor,
  Subs(Options o) {
    Tree.verbose = verbose = o.verbose ;
    int w = o.width ;
    String letters = o.letters ;
    if (letters != null) {
      Mset mset = new Mset(letters) ;
      coder = mset.getCoder() ;
      ctrl = new ExactWords(o) ;
      ctrl =  new Compose (mset, ctrl) ;
    } else {
      coder = new NoCoder() ;
      ctrl = null ;
    }
    Tree.coder = coder ;

    Tree tw = null ;
    start = null ;
    String line ;


    //    System.err.println("CTRL: " + ctrl) ;
    try {
      BufferedReader inb = new BufferedReader (new FileReader (o.dico)) ;    
      while ((line = inb.readLine()) != null) {
        int n = line.length() ;
        if (n >= w) {
          line = line.toLowerCase() ;
          treatWord(line) ;
          start = insertSub(start, line.substring(0, w), n == w) ;
          for (int k = 1 ; w+k < n ; k++) {
	    tw = insertSub(tw, line.substring(k, k+w), false) ;
          }
          if (n != w) {
            tw = insertSub(tw, line.substring(n-w, n), true) ;
          }
        }
      }
    } catch (FileNotFoundException e) {
      System.err.println("Cannot open " + o.dico + ": " + e.getMessage()) ;
      System.exit(2) ;
    } catch (IOException e) {
      System.err.println("Malaise: " + e.getMessage()) ;
      System.exit(2) ;
    }
    if (verbose > 1) {
      System.err.println("START:") ;
      Tree.dump(System.err, start) ;
      System.err.println("SUBS:") ;
      Tree.dump(System.err, tw) ;
    }
    start = Tree.simplif(start, tw) ;
    /*
    Tree.putUp(tw, tw) ;
    Tree.putUp(start, tw) ;
    */
  }
}
